
#pragma once

#include <windows.h>

class CTicket
{
protected:
	HANDLE m_hEvent;
public:
	CTicket()
	{
		m_hEvent = CreateEvent( NULL, FALSE, FALSE, NULL );
	}

	virtual ~CTicket()
	{
		CloseHandle( m_hEvent );
	}

	bool Wait(DWORD sec)
	{
		DWORD wait = WaitForSingleObject( m_hEvent, sec );
		return wait == WAIT_OBJECT_0;
	}

	bool Set()
	{
		SetEvent( m_hEvent );
	}

};
